#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include </usr/include/semaphore.h>
#include <unistd.h>

#define MAX 100000

pthread_mutex_t mux_a;  /* enforce mutual exclusion to shared data */
int a;
pthread_mutex_t mux_b;  /* enforce mutual exclusion to shared data */
int b;

void *Producer(void *arg) {
  int i, item;
  
  for (i=0; i < MAX; i++) {
    pthread_mutex_lock(&mux_a);  /* If another thread uses the buffer, wait */
    a++;
    pthread_mutex_lock(&mux_b);  /* If another thread uses the buffer, wait */
    b=a;
    printf("P %i %i\n", a,b);
    pthread_mutex_unlock(&mux_b);  /* Release the buffer */
    pthread_mutex_unlock(&mux_a);  /* Release the buffer */
    usleep(700);
  }
  return NULL;
}

void *Consumer(void *arg) {
  int i, item;
  
  for (i=0; i < MAX; i++) {
    pthread_mutex_lock(&mux_b);  /* If another thread uses the buffer, wait */
    b--;
    pthread_mutex_lock(&mux_a);  /* If another thread uses the buffer, wait */
    a=b;
    printf("C %i %i\n", a,b);
    pthread_mutex_unlock(&mux_a);  /* Release the buffer */
    pthread_mutex_unlock(&mux_b);  /* Release the buffer */
    usleep(700);
  }
  return NULL;
}

int main() {
  pthread_t idP, idC;
  
  pthread_mutex_init(&mux_a, NULL);
  pthread_mutex_init(&mux_b, NULL);
  pthread_create(&idP, NULL, Producer, NULL);
  pthread_create(&idC, NULL, Consumer, NULL);
  
  pthread_join(idP, NULL);
  pthread_join(idC, NULL);
}
